<?php

/**
 * Banner Section
 *
 * @package gamers_studio
 */

$wp_customize->add_section(
	'gamers_studio_banner_section',
	array(
		'panel'    => 'gamers_studio_front_page_options',
		'title'    => esc_html__( 'Banner Section', 'gamers-studio' ),
		'priority' => 10,
	)
);

// Banner Section - Enable Section.
$wp_customize->add_setting(
	'gamers_studio_enable_banner_section',
	array(
		'default'           => false,
		'sanitize_callback' => 'gamers_studio_sanitize_switch',
	)
);

$wp_customize->add_control(
	new Gamers_Studio_Toggle_Switch_Custom_Control(
		$wp_customize,
		'gamers_studio_enable_banner_section',
		array(
			'label'    => esc_html__( 'Enable Banner Section', 'gamers-studio' ),
			'section'  => 'gamers_studio_banner_section',
			'settings' => 'gamers_studio_enable_banner_section',
		)
	)
);

if ( isset( $wp_customize->selective_refresh ) ) {
	$wp_customize->selective_refresh->add_partial(
		'gamers_studio_enable_banner_section',
		array(
			'selector' => '#gamers_studio_banner_section .section-link',
			'settings' => 'gamers_studio_enable_banner_section',
		)
	);
}


// Banner Section - Banner Slider Content Type.
$wp_customize->add_setting(
	'gamers_studio_banner_slider_content_type',
	array(
		'default'           => 'post',
		'sanitize_callback' => 'gamers_studio_sanitize_select',
	)
);

$wp_customize->add_control(
	'gamers_studio_banner_slider_content_type',
	array(
		'label'           => esc_html__( 'Select Banner Slider Content Type', 'gamers-studio' ),
		'section'         => 'gamers_studio_banner_section',
		'settings'        => 'gamers_studio_banner_slider_content_type',
		'type'            => 'select',
		'active_callback' => 'gamers_studio_is_banner_slider_section_enabled',
		'choices'         => array(
			'page' => esc_html__( 'Page', 'gamers-studio' ),
			'post' => esc_html__( 'Post', 'gamers-studio' ),
		),
	)
);

// Banner Slider Category Setting.
$wp_customize->add_setting('gamers_studio_banner_slider_category', array(
	'default'           => 'slider',
	'sanitize_callback' => 'sanitize_text_field',
));

// Add custom control for Banner Slider Category with conditional visibility.
$wp_customize->add_control(new Gamers_Studio_Customize_Category_Dropdown_Control($wp_customize, 'gamers_studio_banner_slider_category', array(
	'label'    => __('Select Banner Category', 'gamers-studio'),
	'section'  => 'gamers_studio_banner_section',
	'settings' => 'gamers_studio_banner_slider_category',
	'active_callback' => function() use ($wp_customize) {
		return $wp_customize->get_setting('gamers_studio_banner_slider_content_type')->value() === 'post';
	},
)));

for ( $gamers_studio_i = 1; $gamers_studio_i <= 3; $gamers_studio_i++ ) {

	// Banner Section - Select Banner Post.
	$wp_customize->add_setting(
		'gamers_studio_banner_slider_content_post_' . $gamers_studio_i,
		array(
			'sanitize_callback' => 'absint',
		)
	);

	$wp_customize->add_control(
		'gamers_studio_banner_slider_content_post_' . $gamers_studio_i,
		array(
			/* translators: %d: Post Count. */
			'label'           => sprintf( esc_html__( 'Select Post %d', 'gamers-studio' ), $gamers_studio_i ),
			'description'     => sprintf( esc_html__( 'Kindly :- Select a Post based on the category selected in the upper settings', 'gamers-studio' ), $gamers_studio_i ),
			'section'         => 'gamers_studio_banner_section',
			'settings'        => 'gamers_studio_banner_slider_content_post_' . $gamers_studio_i,
			'active_callback' => 'gamers_studio_is_banner_slider_section_and_content_type_post_enabled',
			'type'            => 'select',
			'choices'         => gamers_studio_get_post_choices(),
		)
	);

	// Banner Section - Select Banner Page.
	$wp_customize->add_setting(
		'gamers_studio_banner_slider_content_page_' . $gamers_studio_i,
		array(
			'sanitize_callback' => 'absint',
		)
	);

	$wp_customize->add_control(
		'gamers_studio_banner_slider_content_page_' . $gamers_studio_i,
		array(
			/* translators: %d: Page Count. */
			'label'           => sprintf( esc_html__( 'Select Page %d', 'gamers-studio' ), $gamers_studio_i ),
			'section'         => 'gamers_studio_banner_section',
			'settings'        => 'gamers_studio_banner_slider_content_page_' . $gamers_studio_i,
			'active_callback' => 'gamers_studio_is_banner_slider_section_and_content_type_page_enabled',
			'type'            => 'select',
			'choices'         => gamers_studio_get_page_choices(),
		)
	);

	// Banner Section - Button Label.
	$wp_customize->add_setting(
		'gamers_studio_banner_button_label_' . $gamers_studio_i,
		array(
			'default'           => '',
			'sanitize_callback' => 'sanitize_text_field',
		)
	);

	$wp_customize->add_control(
		'gamers_studio_banner_button_label_' . $gamers_studio_i,
		array(
			/* translators: %d: Button Label Count. */
			'label'           => sprintf( esc_html__( 'Button Label %d', 'gamers-studio' ), $gamers_studio_i ),
			'section'         => 'gamers_studio_banner_section',
			'settings'        => 'gamers_studio_banner_button_label_' . $gamers_studio_i,
			'type'            => 'text',
			'active_callback' => 'gamers_studio_is_banner_slider_section_enabled',
		)
	);

	// Banner Section - Button Link.
	$wp_customize->add_setting(
		'gamers_studio_banner_button_link_' . $gamers_studio_i,
		array(
			'default'           => '',
			'sanitize_callback' => 'esc_url_raw',
		)
	);

	$wp_customize->add_control(
		'gamers_studio_banner_button_link_' . $gamers_studio_i,
		array(
			/* translators: %d: Button Link Count. */
			'label'           => sprintf( esc_html__( 'Button Link %d', 'gamers-studio' ), $gamers_studio_i ),
			'section'         => 'gamers_studio_banner_section',
			'settings'        => 'gamers_studio_banner_button_link_' . $gamers_studio_i,
			'type'            => 'url',
			'active_callback' => 'gamers_studio_is_banner_slider_section_enabled',
		)
	);
}

// Banner Button Label Color
$wp_customize->add_setting(
	'gamers_studio_banner_btn_color',
	array(
		'default' => '',
		'sanitize_callback' => 'sanitize_hex_color',
	)
);
$wp_customize->add_control(new WP_Customize_Color_Control($wp_customize,'gamers_studio_banner_btn_color',array(
			'label' => __('Banner Button Label Color','gamers-studio'),
			'section' => 'gamers_studio_banner_section',
			'settings' => 'gamers_studio_banner_btn_color',
			'active_callback' => 'gamers_studio_is_banner_slider_section_enabled',
		)
	)
);

// Banner Button Background Color
$wp_customize->add_setting('gamers_studio_banner_btn_bg_color',array(
		'default' => '',
		'sanitize_callback' => 'sanitize_hex_color',
	)
);
$wp_customize->add_control(new WP_Customize_Color_Control($wp_customize,'gamers_studio_banner_btn_bg_color',array(
			'label' => __('Banner Button Background Color','gamers-studio'),
			'section' => 'gamers_studio_banner_section',
			'settings' => 'gamers_studio_banner_btn_bg_color',
			'active_callback' => 'gamers_studio_is_banner_slider_section_enabled',
		)
	)
);


$wp_customize->add_setting( 
	'gamers_studio_banner_settings_upgraded_features',
	array(
		'sanitize_callback' => 'sanitize_text_field'
	)
);

$wp_customize->add_control(
	'gamers_studio_banner_settings_upgraded_features', 
	array(
		'type'=> 'hidden',
		'description' => "
			<div class='customizer-upgraded-features'>
				<i class='fas fa-info-circle'></i>
				<span class='pro-text'>
					Unlock Premium <strong>Features</strong> ?<br>
					<a target='_blank' href='". esc_url(GAMERS_STUIDO_PREMIUM_PAGE) ." '>Upgrade Pro</a>
				</div>
			</div>
		",
		'section' => 'gamers_studio_banner_section'
	)
);